package com.ruoyi.generator.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.annotation.Anonymous;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.text.Convert;
import com.ruoyi.common.exception.user.ProjectException;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.ServletUtils;
import com.ruoyi.generator.domain.Community.CommunityReportData;
import com.ruoyi.generator.domain.Community.CommunityTagBlock;
import com.ruoyi.generator.domain.Community.CommunityUserNotification;
import com.ruoyi.generator.domain.Community.CommunityUserPrivacy;
import com.ruoyi.generator.mapper.community.CommunityReportDataMapper;
import com.ruoyi.generator.service.ICommunityNotificationService;
import com.ruoyi.generator.service.ICommunityPrivacyService;
import com.ruoyi.generator.service.ICommunityReportDataService;
import com.ruoyi.generator.vo.CommunityUserNotificationVo;
import com.ruoyi.generator.vo.CommunityUserPrivacyVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Objects;

/**
 * 社区设置管理
 *
 * @author fangQing
 */
@Api(tags = "社区举报管理")
@RestController
@RequestMapping("/community/report")
public class CommunityReportController {


    @Autowired
    private ICommunityNotificationService communityNotificationService;

    @Autowired
    private ICommunityPrivacyService communityPrivacyService;

    @Autowired
    private CommunityReportDataMapper communityReportDataMapper;

    /**
     * 获取举报类型信息
     * @param
     * @return 获取举报类型信息
     */
    @ApiOperation("获取举报类型信息")
    @GetMapping("/reportTypes")
    //@Anonymous
    public AjaxResult reportTypes(String type) {

        int pageNum = Convert.toInt(ServletUtils.getParameter("pageNum"), 1);
        int pageSize = Convert.toInt(ServletUtils.getParameter("pageSize"), 10);
        int offset = (pageNum - 1) * pageSize;
        Page<CommunityReportData> page = new Page<>(offset, pageSize);

        List<CommunityReportData> communityReportData = null ;
        try {
            QueryWrapper<CommunityReportData> queryWrapper = new QueryWrapper<CommunityReportData>()
                    .eq("type", type)
                    .and((wrapper) -> {
                        wrapper.ne("is_delete", true).or().isNull("is_delete");
                    });

           communityReportData = communityReportDataMapper.selectPage(page, queryWrapper).getRecords();

        } catch (Exception e) {
            System.out.println(e.getMessage());
            throw new ProjectException();
        }

        return AjaxResult.success(communityReportData);
    }

}
